/**
 * shows the moves of the rook , it can move in a straight line horizontally or vertically.
 *@author kimiadorani
 *@version 1.0
 *@since 2019-5-7
 */
public class Rook extends Piece {


    public Rook(Cell cell, PieceColor pieceColor) {
        super(cell, pieceColor) ;
    }

    /**
     * isValidMove is the method which has been overrided from the piece class
     * here we check if the move rook wants to make is possible or not!
     * @param c the cel rook is in it
     * @param board
     * @param pw the white player piece
     * @param pb the black player piece
     * @return true if the moves were possible and false if they were not
     */
    /**
     * shows the moves of the rook , it can move straight
     * @author kimiadorani
     * @version 1.0

     */

        @Override
        public boolean isValidMove(Cell c, Cell board[][], Piece pw[], Piece pb[]) {
            if (super.isDeleted()) return false ;
            int sw=0 ;
            if (super.getPieceColor() == PieceColor.BLACK) {
                for (Piece p:pw) {
                    if (!p.isDeleted() && p.getCell().getRow()==c.getRow() && p.getCell().getCol()==c.getCol()) sw=1 ;
                }
            }
            else {
                for (Piece p:pb) {
                    if (!p.isDeleted() && p.getCell().getRow()==c.getRow() && p.getCell().getCol()==c.getCol()) sw=1 ;
                }
            }
            if ( (
                    (this.getCell().getCol() == c.getCol()) || (this.getCell().getRow() == c.getRow())
            ) && (c.isEmpty() || (!c.isEmpty() && sw==1))
                    ) {
                if (this.getCell().getCol() == c.getCol() && this.getCell().getRow() < c.getRow()) {
                    for (int i=1 ; i<8 ; ++i) {
                        if (this.getCell().getRow()+i == c.getRow() && sw==1) break ;
                        if (!board[this.getCell().getRow()+i][c.getCol()].isEmpty()) return false;
                        if (this.getCell().getRow()+i == c.getRow()) break ;
                    }
                }
                if (this.getCell().getCol() == c.getCol() && this.getCell().getRow() > c.getRow()) {
                    for (int i=-1 ; i>-8 ; --i) {
                        if (this.getCell().getRow()+i == c.getRow() && sw==1) break ;
                        if (!board[this.getCell().getRow()+i][c.getCol()].isEmpty()) return false;
                        if (this.getCell().getRow()+i == c.getRow()) break ;
                    }
                }
                if (this.getCell().getCol() < c.getCol() && this.getCell().getRow() == c.getRow()) {
                    for (int i=1 ; i<8 ; ++i) {
                        if (this.getCell().getCol()+i == c.getCol() && sw==1) break ;
                        if (!board[c.getRow()][this.getCell().getCol()+i].isEmpty()) return false;
                        if (this.getCell().getCol()+i == c.getCol()) break ;
                    }
                }
                if (this.getCell().getCol() > c.getCol() && this.getCell().getRow() == c.getRow()) {
                    for (int i=-1 ; i>-8 ; --i) {
                        if (this.getCell().getCol()+i == c.getCol() && sw==1) break ;
                        if (!board[c.getRow()][this.getCell().getCol()+i].isEmpty()) return false;
                        if (this.getCell().getCol()+i == c.getCol()) break ;
                    }
                }
                return true ;
            }
            else return false ;
        }
}
